Attribute VB_Name = "Declarations"
Option Private Module
Option Explicit

Public Const DATA_FIRST_ROW = 2

Public Const NO_CONTENT_PLACEHOLDER = " "
Public Const NO_MEDIA_PLACEHOLDER = " "

Public Const STATUS_CANCELED = ""
Public Const BOOL_TEXT_YES = ""
Public Const BOOL_TEXT_NO = ""

Public Const SHEET_CONTENT = ""
Public Const SHEET_OPTIONS = ""
Public Const SHEET_ATTRIBUTES = ""
Public Const SHEET_CONFIG = ""

Public Const TABLE_WORKERS = "t_Person"
Public Const TABLE_MARKERS = "t_Markers"
Public Const TABLE_TAGS = "t_Tags"

Public Const URL_PREFIX_TASK = "https://rk.greatbook.ru/tasks/"
Public Const URL_PREFIX_CONTENT = "https://rk.greatbook.ru/widgets?link=task&id="

Public Const EXPORTER_CONFIG_FILE = "exporter.ini"
Public Const EXPORTER_EXECUTABLE = "exporter.exe"

Public Const PREFIX_IMMUTABLE = " "
Public Const SUFFIX_IMMUTABLE = " (++)"

Public Enum TUpdateStatus
  T_UPD_UNDEF = 0
  [_First] = 1
  
  T_UPD_COMPLETE = 1
  T_UPD_IGNORE = 2
  T_UPD_AUTO = 3
  T_UPD_ONCE = 4
  T_UPD_ALWAYS = 5
  
  [_Last] = 5
End Enum

Public Function InferContentFromTask(sTask$) As String
  Dim sContent$: sContent = sTask
  If sContent Like PREFIX_IMMUTABLE & "*" Then _
    sContent = VBA.Right(sContent, VBA.Len(sContent) - VBA.Len(PREFIX_IMMUTABLE))
  If sContent Like "*" & SUFFIX_IMMUTABLE Then _
    sContent = VBA.Left(sContent, VBA.Len(sContent) - VBA.Len(SUFFIX_IMMUTABLE))
  InferContentFromTask = sContent
End Function

Public Function UpdateStatusFromText(sText$) As TUpdateStatus
  If sText = "" Then
    UpdateStatusFromText = T_UPD_COMPLETE
  ElseIf sText = "" Then
    UpdateStatusFromText = T_UPD_IGNORE
  ElseIf sText = "" Then
    UpdateStatusFromText = T_UPD_AUTO
  ElseIf sText = "" Then
    UpdateStatusFromText = T_UPD_ONCE
  ElseIf sText = "" Then
    UpdateStatusFromText = T_UPD_ALWAYS
  Else
    UpdateStatusFromText = T_UPD_UNDEF
  End If
End Function

Public Function UpdateStatusToText(iStatus As TUpdateStatus) As String
  Select Case iStatus
  Case T_UPD_UNDEF: UpdateStatusToText = ""
  Case T_UPD_COMPLETE: UpdateStatusToText = ""
  Case T_UPD_IGNORE: UpdateStatusToText = ""
  Case T_UPD_AUTO: UpdateStatusToText = ""
  Case T_UPD_ONCE: UpdateStatusToText = ""
  Case T_UPD_ALWAYS: UpdateStatusToText = ""
  Case Else: UpdateStatusToText = ""
  End Select
End Function


