VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "InfoConfig"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const S_CONFIG_KEY = 1
Private Const S_CONFIG_VALUE = 2
Private Const S_CONFIG_COMMENT = 3

Private Enum AppdataRows
  [_First] = 2
  
  R_APP_FILTER_TASK = 2
  R_APP_FILTER_DEPARTMENT = 3
  R_APP_FILTER_STATUS = 4
  R_APP_FILTER_RESPONSIBLE = 5
  R_APP_FILTER_SUPERVISOR = 6
  R_APP_FILTER_EXECUTOR = 7
  R_APP_FILTER_OBSERVER = 8
  
  R_APP_FILTER_CREATED_BEGIN = 9
  R_APP_FILTER_CREATED_END = 10
  R_APP_FILTER_TARGET_BEGIN = 11
  R_APP_FILTER_TARGET_END = 12
  
  R_APP_OUTPUT = 13
  R_APP_SCAN_TASKS = 14
  R_APP_SCAN_CONTENT = 15
  R_APP_OUTPUT_CONTENT = 16
  R_APP_ACCESS_TOKEN = 17
  
  [_Last] = 17
End Enum

Private Enum UserRows
  [_First] = 19
  
  R_USER_NAME = 19
  R_USER_LOGIN = 20
  R_USER_PASSWORD = 21
  
  [_Last] = 21
End Enum

Private Enum OptionsRows
  [_First] = 23
  
  R_OPT_DEBUG = 23
  R_OPT_TESTRUN = 24
  R_OPT_TIMEOUT = 25

  [_Last] = 25
End Enum

Private data_ As Excel.Worksheet
Private content_ As DB_Content

Public Function Init(iData As Excel.Worksheet, iContent As DB_Content)
  Set data_ = iData
  Set content_ = iContent
End Function

Public Function SetScanContent(bScanContent As Boolean)
  data_.Cells(R_APP_SCAN_CONTENT, S_CONFIG_VALUE) = IIf(bScanContent, "true", "false")
End Function

Public Function SetScanTasks(bScanContent As Boolean)
  data_.Cells(R_APP_SCAN_TASKS, S_CONFIG_VALUE) = IIf(bScanContent, "true", "false")
End Function

Public Function ConfigFilePath() As String
  ConfigFilePath = data_.Parent.Path & "\" & EXPORTER_CONFIG_FILE
End Function

Public Function OutputFileTasks() As String
  OutputFileTasks = data_.Parent.Path & "\" & data_.Cells(R_APP_OUTPUT, S_CONFIG_VALUE)
End Function

Public Function OutputFileContent() As String
  OutputFileContent = data_.Parent.Path & "\" & data_.Cells(R_APP_OUTPUT_CONTENT, S_CONFIG_VALUE)
End Function

Public Function ScanContent() As Boolean
  ScanContent = data_.Cells(R_APP_SCAN_CONTENT, S_CONFIG_VALUE)
End Function

Public Function ScanTasks() As Boolean
  ScanTasks = data_.Cells(R_APP_SCAN_TASKS, S_CONFIG_VALUE)
End Function

Public Function CreateConfigFile()
  Dim nRow&
  Dim sValue$, sKey$
  Dim iOut As New ADODB.Stream: iOut.Charset = "utf-8"
  Call iOut.Open
  
  Call iOut.WriteText("[AppData]", adWriteLine)
  For nRow = AppdataRows.[_First] To AppdataRows.[_Last] Step 1
    sKey = data_.Cells(nRow, S_CONFIG_KEY)
    sValue = data_.Cells(nRow, S_CONFIG_VALUE)
    Call iOut.WriteText(Fmt("{1}={2}", sKey, sValue), adWriteLine)
  Next nRow
  Call PrepareLists(iOut)
  
  Call iOut.WriteText("[Options]", adWriteLine)
  For nRow = OptionsRows.[_First] To OptionsRows.[_Last] Step 1
    sKey = data_.Cells(nRow, S_CONFIG_KEY)
    sValue = data_.Cells(nRow, S_CONFIG_VALUE)
    Call iOut.WriteText(Fmt("{1}={2}", sKey, sValue), adWriteLine)
  Next nRow
  
  Call iOut.WriteText("[UserData]", adWriteLine)
  For nRow = UserRows.[_First] To UserRows.[_Last] Step 1
    sKey = data_.Cells(nRow, S_CONFIG_KEY)
    sValue = data_.Cells(nRow, S_CONFIG_VALUE)
    Call iOut.WriteText(Fmt("{1}={2}", sKey, sValue), adWriteLine)
  Next nRow
  
  Dim iOutNoBOM As New ADODB.Stream
  iOutNoBOM.Type = adTypeBinary
  Call iOutNoBOM.Open
    
  iOut.Position = 3
  Call iOut.CopyTo(iOutNoBOM)
  
  Call iOutNoBOM.SaveToFile(ConfigFilePath, adSaveCreateOverWrite)
  Call iOutNoBOM.Close

  Call iOut.Close
End Function

Public Function DeleteConfigFile()
  Call Kill(ConfigFilePath)
End Function

' ========
Private Function PrepareLists(iOut As ADODB.Stream) As String
  Dim iExclude$: iExclude = ""
  Dim iInclude$: iInclude = ""
  Dim iContent As IteratorContent: Set iContent = content_.IBegin
  Dim iStatus As TUpdateStatus
  Do While Not iContent.IsDone
    Call iContent.RecalculateStatus
    If iContent.IsIgnored Then
      If iExclude <> "" Then iExclude = iExclude & ";"
      iExclude = iExclude & iContent.TaskID
    End If
    If iContent.NeedsUpdate Then
      If iInclude <> "" Then iInclude = iInclude & ";"
      iInclude = iInclude & iContent.TaskID
    End If
    Call iContent.Increment
  Loop

  Call iOut.WriteText(Fmt("{1}={2}", "ExcludeID", iExclude), adWriteLine)
  Call iOut.WriteText(Fmt("{1}={2}", "IncludeID", iInclude), adWriteLine)
End Function
