VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "IteratorAttribute"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' _A_ Attrtibutes structure
Private Enum AttributesStruct
  [_First] = 1
  
  S_A_CONTENT_NAME = 1
  S_A_ATTRIBUTE = 2
  S_A_VALUE = 3
  S_A_INPUT_METHOD = 4

  [_Last] = 4
End Enum

Public row_ As Long

Private data_ As Excel.Worksheet

Public Sub Init(target As Excel.Worksheet, Optional tRow& = DATA_FIRST_ROW)
  Set data_ = target
  row_ = tRow
End Sub

Public Function Increment(Optional inc& = 1)
  If row_ + inc > 0 Then _
    row_ = row_ + inc
End Function

Public Function GoFirst()
  row_ = DATA_FIRST_ROW
End Function

Public Function GoLast()
  row_ = GetLastRow
End Function

Public Function GoEmpty()
  Call GoLast
  Call Increment
End Function

Public Function IsDone() As Boolean
  IsDone = row_ > GetLastRow
End Function

Public Function SyncWith(iInput As IteratorAttribute)
  ContentName = iInput.ContentName
  Attr = iInput.Attr
  Value = iInput.Value
  InputMethod = iInput.InputMethod
End Function

' ======== Property Get =========
Public Property Get ContentName() As String
  ContentName = data_.Cells(row_, S_A_CONTENT_NAME)
End Property

Public Property Get Attr() As String
  Attr = data_.Cells(row_, S_A_ATTRIBUTE)
End Property

Public Property Get Value() As String
  Value = data_.Cells(row_, S_A_VALUE)
End Property

Public Property Get InputMethod() As String
  InputMethod = data_.Cells(row_, S_A_INPUT_METHOD)
End Property

' ==== Property Let ====
Public Property Let ContentName(newVal$)
  data_.Cells(row_, S_A_CONTENT_NAME) = newVal
End Property

Public Property Let Attr(newVal$)
  data_.Cells(row_, S_A_ATTRIBUTE) = newVal
End Property

Public Property Let Value(newVal$)
  data_.Cells(row_, S_A_VALUE) = newVal
End Property

Public Property Let InputMethod(newVal$)
  data_.Cells(row_, S_A_INPUT_METHOD) = newVal
End Property

' =======
Private Function GetLastRow() As Long
  GetLastRow = data_.Cells(data_.Rows.Count, 1).End(xlUp).Row
End Function
