VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "IteratorCSVContent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' _I_ Input CSV structure
Private Enum InputStruct
  [_First] = 1
  
  S_I_TASK_ID = 1
  S_I_BIBLIO_NAME = 2
  S_I_CHANGE_SCORE = 3
  S_I_DEPARTMENT = 4
  S_I_RESPONSIBLE = 5
  S_I_DEFINITION = 6
  S_I_OBJECT_TYPE = 7
  S_I_MARKERS = 8
  S_I_TAGS = 9
  S_I_SOURCE = 10
  S_I_ELECTRON_BRE = 11
  S_I_MAIN_PAGE = 12
  S_I_IS_GENERAL = 13
  S_I_ACTUALIZE_PERIOD = 14
  S_I_AGE_RESTRICTION = 15
  S_I_AUTHOR = 16
  S_I_EDITOR = 17

  [_Last] = 17
End Enum

Public row_ As Long

Private data_ As Excel.Worksheet

Public Sub Init(target As Excel.Worksheet, Optional tRow& = 1)
  Set data_ = target
  row_ = tRow
End Sub

Public Function Increment(Optional inc& = 1)
  If row_ + inc > 0 Then _
    row_ = row_ + inc
End Function

Public Function GoFirst()
  row_ = 1
End Function

Public Function GoLast()
  row_ = data_.Columns(S_I_TASK_ID).Find(vbNullString, LookAt:=xlWhole).Row - 1
End Function

Public Property Get CountRows() As Long
  CountRows = data_.Columns(S_I_TASK_ID).Find(vbNullString, LookAt:=xlWhole).Row - 1
End Property

Public Function IsDone() As Boolean
  IsDone = data_.Cells(row_, S_I_TASK_ID) = vbNullString
End Function

'===== Propertiy Get =====
Public Property Get TaskID() As String
  TaskID = data_.Cells(row_, S_I_TASK_ID)
End Property

Public Property Get BiblioName() As String
  BiblioName = data_.Cells(row_, S_I_BIBLIO_NAME)
End Property

Public Property Get ChangeScore() As String
  ChangeScore = data_.Cells(row_, S_I_CHANGE_SCORE)
End Property

Public Property Get Department() As String
  Department = data_.Cells(row_, S_I_DEPARTMENT)
End Property

Public Property Get Responsible() As String
  Responsible = data_.Cells(row_, S_I_RESPONSIBLE)
End Property

Public Property Get Definition() As String
  Definition = data_.Cells(row_, S_I_DEFINITION)
End Property

Public Property Get ObjectType() As String
  ObjectType = data_.Cells(row_, S_I_OBJECT_TYPE)
End Property

Public Property Get Markers() As String
  Markers = data_.Cells(row_, S_I_MARKERS)
End Property

Public Property Get Tags() As String
  Tags = data_.Cells(row_, S_I_TAGS)
End Property

Public Property Get Source() As String
  Source = data_.Cells(row_, S_I_SOURCE)
End Property

Public Property Get ElectronBre() As String
  ElectronBre = data_.Cells(row_, S_I_ELECTRON_BRE)
End Property

Public Property Get MainPage() As String
  MainPage = data_.Cells(row_, S_I_MAIN_PAGE)
End Property

Public Property Get IsGeneral() As String
  IsGeneral = data_.Cells(row_, S_I_IS_GENERAL)
End Property

Public Property Get ActualizePeriod() As String
  ActualizePeriod = data_.Cells(row_, S_I_ACTUALIZE_PERIOD)
End Property

Public Property Get AgeRestriction() As String
  AgeRestriction = data_.Cells(row_, S_I_AGE_RESTRICTION)
End Property

Public Property Get Author() As String
  Author = data_.Cells(row_, S_I_AUTHOR)
End Property

Public Property Get Editor() As String
  Editor = data_.Cells(row_, S_I_EDITOR)
End Property
