VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "IteratorCSVTasks"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' _I_ Input CSV structure
Private Enum InputStruct
  [_First] = 1
  
  S_I_TASK_TYPE = 1
  S_I_STATUS = 2
  S_I_CONTENT_NAME_DB = 3
  S_I_SUPERVISOR = 4
  S_I_EXECUTOR = 5
  S_I_TARGET_DATE = 6
  S_I_TASK_ID = 7
  S_I_TASK_NAME = 8
  S_I_PARENT_ID = 9

  [_Last] = 9
End Enum

Public row_ As Long

Private data_ As Excel.Worksheet
Private workers_ As DB_Workers

Public Sub Init(target As Excel.Worksheet, dbWorkers As DB_Workers, Optional tRow& = 1)
  Set data_ = target
  row_ = tRow
  Set workers_ = dbWorkers
End Sub

Public Function Increment(Optional inc& = 1)
  If row_ + inc > 0 Then _
    row_ = row_ + inc
End Function

Public Function GoFirst()
  row_ = 1
End Function

Public Function GoLast()
  row_ = data_.Columns(S_I_TASK_TYPE).Find(vbNullString, LookAt:=xlWhole).Row - 1
End Function

Public Property Get CountRows() As Long
  CountRows = data_.Columns(S_I_TASK_TYPE).Find(vbNullString, LookAt:=xlWhole).Row - 1
End Property

Public Function IsDone() As Boolean
  IsDone = data_.Cells(row_, S_I_TASK_TYPE) = vbNullString
End Function

Public Function IsCanceled() As Boolean
  IsCanceled = Status = STATUS_CANCELED
End Function

Public Function HasContent() As Boolean
  Dim sContent$: sContent = ContentNameDB
  HasContent = sContent <> NO_CONTENT_PLACEHOLDER And sContent <> NO_MEDIA_PLACEHOLDER
End Function

'===== Propertiy Get =====
Public Property Get TaskType() As String
  Dim sText$: sText = data_.Cells(row_, S_I_TASK_TYPE)
  If sText = "   " Then
    TaskType = "   "
  Else
    TaskType = CapitalizeFirstLetter(VBA.LCase(sText))
  End If
End Property

Public Property Get Status() As String
  Status = data_.Cells(row_, S_I_STATUS)
End Property

Public Property Get ContentName() As String
  If Not HasContent Then
    ContentName = InferContentFromTask(TaskName)
  Else
    ContentName = ContentNameDB
  End If
End Property

Public Property Get ContentNameDB() As String
  ContentNameDB = data_.Cells(row_, S_I_CONTENT_NAME_DB)
End Property

Public Property Get Supervisor() As String
  Supervisor = workers_.ExpandShortname(data_.Cells(row_, S_I_SUPERVISOR))
End Property

Public Property Get Executor() As String
  Executor = workers_.ExpandShortname(data_.Cells(row_, S_I_EXECUTOR))
End Property

Public Property Get TargetDate() As Long
  TargetDate = VBA.CDate(data_.Cells(row_, S_I_TARGET_DATE))
End Property

Public Property Get TaskID() As String
  TaskID = data_.Cells(row_, S_I_TASK_ID)
End Property

Public Property Get TaskName() As String
  TaskName = data_.Cells(row_, S_I_TASK_NAME)
End Property

Public Property Get ParentID() As String
  ParentID = data_.Cells(row_, S_I_PARENT_ID)
End Property
