Attribute VB_Name = "z_UIMessages"
'       
Option Explicit

Public Enum MsgCode
  MSG_OK = 0

  EM_FILE_CANNOT_OPEN
  EM_CANNOT_EXEC
  EM_MISSING_FILE
  EM_ITEM_EXISTS
  EM_MISSING_EXEC
  
  IM_IMPORT_SUCCESS
  IM_DATA_DELETED
  
 ' QM_MERGE_WARNING
End Enum

Private g_UI As API_UserInteraction

Public Function UserInteraction() As API_UserInteraction
  If g_UI Is Nothing Then _
    Set g_UI = New API_UserInteraction
  Set UserInteraction = g_UI
End Function

Public Function SetUserInteraction(newUI As API_UserInteraction)
  Set g_UI = newUI
End Function

Public Function UIShowMessage(theCode As MsgCode, ParamArray params() As Variant)
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Select Case theCode
  Case EM_FILE_CANNOT_OPEN:     Call MsgBox(Fmt("    {1}", unwrapped), vbExclamation)
  Case EM_CANNOT_EXEC:          Call MsgBox(Fmt("   " & vbNewLine & """{1}""", unwrapped), vbExclamation)
  Case EM_MISSING_FILE:         Call MsgBox(Fmt("   {1}", unwrapped), vbExclamation)
  Case EM_ITEM_EXISTS:          Call MsgBox(Fmt("    : {1}", unwrapped), vbExclamation)
  Case EM_MISSING_EXEC:         Call MsgBox(Fmt("    Python: {1}", unwrapped), vbExclamation)
  
  Case IM_IMPORT_SUCCESS:       Call MsgBox("  ", vbInformation)
  Case IM_DATA_DELETED:         Call MsgBox(" ", vbInformation)

  Case Else:                    Call MsgBox("  ", vbCritical)
  End Select
End Function

Public Function UIAskQuestion(theCode As MsgCode, ParamArray params() As Variant) As Boolean
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Dim answer&: answer = vbNo
  Select Case theCode
 ' Case QM_DELETE_LAW:           answer = MsgBox(Fmt("!    {1}  !" & vbNewLine & "?", unwrapped), vbYesNo + vbQuestion)
  
  Case Else:                    Call MsgBox("  ", vbCritical)
  End Select
  UIAskQuestion = answer = vbYes
End Function
