'''BRE browser options'''
from selenium.webdriver.chrome.options import Options


def get_browser_options(show_window: bool) -> Options:
    '''Prepare browser options for BRE portal'''
    options = Options()
    if not show_window:
        options.add_argument('--headless')

    options.add_argument("--start-maximized")
    options.add_experimental_option('excludeSwitches', ['enable-logging', 'enable-automation'])

    prefs = {"credentials_enable_service": False, "profile.password_manager_enabled": False}
    options.add_experimental_option("prefs", prefs)

    return options
