'''Metadata manipulations'''
import sys
import logging

import portal as bre

if __name__ == '__main__':
    import argparse
    logging.basicConfig(stream=sys.stderr, level=logging.INFO)

    parser = argparse.ArgumentParser(description='BRE automation parameters')
    parser.add_argument('filename')
    parser.add_argument('config', help='Configuration INI file')
    parser.add_argument('input', help ='Input xlsx file')
    parser.add_argument('password', help='Password to access encrypted user data')
    
    args = parser.parse_args(sys.argv)

    config = bre.read_config(args.config)
    config['AppData']['Password'] = args.password

    portal = bre.PortalAPI(config)
    if not portal.set_input(args.input):
        sys.exit()

    sys.exit(portal.import_meta())
